Play DTMF into a call

This code snippet plays DTMF tones into the specified call.

Example

Replace the following variables in the example code:

KeyDescription
VOICE_CALL_ID

The UUID of the call leg.

VOICE_DTMF_DIGITS

Digits representing the DTMF tones that will be played into the call.

Prerequisites

Execute the following command at your terminal prompt to create the JWT for authentication:

export JWT=$(nexmo jwt:generate $PATH_TO_PRIVATE_KEY application_id=$NEXMO_APPLICATION_ID)

Write the code

Add the following to play-dtmf-into-a-call.sh:

curl -X PUT https://api.nexmo.com/v1/calls/$VOICE_CALL_ID/dtmf \
  -H "Authorization: Bearer $JWT"\
  -H "Content-Type: application/json"\
  -d '{"digits": '"$VOICE_DTMF_DIGITS"'}'

View full source

Run your code

Save this file to your machine and run it:

bash play-dtmf-into-a-call.sh

Prerequisites

npm install @vonage/server-sdk

Create a file named play-dtmf-into-a-call.js and add the following code:

const { Vonage } = require('@vonage/server-sdk');

const vonage = new Vonage({
  applicationId: VONAGE_APPLICATION_ID,
  privateKey: VONAGE_PRIVATE_KEY,
});

View full source

Write the code

Add the following to play-dtmf-into-a-call.js:

vonage.voice.playDTMF(VOICE_CALL_ID, VOICE_DTMF_DIGITS)
  .then((resp) => console.log(resp))
  .catch((error) => console.error(error));

View full source

Run your code

Save this file to your machine and run it:

node play-dtmf-into-a-call.js

Prerequisites

Add the following to build.gradle:

implementation 'com.vonage:server-sdk-kotlin:2.1.1'

Create a file named PlayDtmfIntoCall and add the following code to the main method:

val client = Vonage {
    applicationId(VONAGE_APPLICATION_ID)
    privateKeyPath(VONAGE_PRIVATE_KEY_PATH)
}

View full source

Write the code

Add the following to the main method of the PlayDtmfIntoCall file:

val response = client.voice.call(VOICE_CALL_ID).sendDtmf(VOICE_DTMF_DIGITS)

View full source

Run your code

We can use the application plugin for Gradle to simplify the running of our application. Update your build.gradle with the following:

apply plugin: 'application'
mainClassName = project.hasProperty('main') ? project.getProperty('main') : ''

Run the following gradle command to execute your application, replacing com.vonage.quickstart.kt.voice with the package containing PlayDtmfIntoCall:

gradle run -Pmain=com.vonage.quickstart.kt.voice.PlayDtmfIntoCall

Prerequisites

Add the following to build.gradle:

implementation 'com.vonage:server-sdk:9.3.1'

Create a file named SendDtmfToCall and add the following code to the main method:

VonageClient client = VonageClient.builder()
        .applicationId(VONAGE_APPLICATION_ID)
        .privateKeyPath(VONAGE_PRIVATE_KEY_PATH)
        .build();

View full source

Write the code

Add the following to the main method of the SendDtmfToCall file:

var response = client.getVoiceClient().sendDtmf(VOICE_CALL_ID, VOICE_DTMF_DIGITS);
System.out.println(response);

View full source

Run your code

We can use the application plugin for Gradle to simplify the running of our application. Update your build.gradle with the following:

apply plugin: 'application'
mainClassName = project.hasProperty('main') ? project.getProperty('main') : ''

Run the following gradle command to execute your application, replacing com.vonage.quickstart.voice with the package containing SendDtmfToCall:

gradle run -Pmain=com.vonage.quickstart.voice.SendDtmfToCall

Prerequisites

Install-Package Vonage

Write the code

Add the following to PlayDtmfIntoCall.cs:

var credentials = Credentials.FromAppIdAndPrivateKeyPath(VONAGE_APPLICATION_ID, VONAGE_PRIVATE_KEY_PATH);
var client = new VonageClient(credentials);

var command = new DtmfCommand() { Digits = VOICE_DTMF_DIGITS };

var response = await client.VoiceClient.StartDtmfAsync(VOICE_CALL_ID, command);

View full source

Prerequisites

composer require vonage/client

Write the code

Add the following to index.php:

require_once __DIR__ . '/../../vendor/autoload.php';

$keypair = new \Vonage\Client\Credentials\Keypair(file_get_contents(VONAGE_APPLICATION_PRIVATE_KEY_PATH), VONAGE_APPLICATION_ID);
$client = new \Vonage\Client($keypair);

$client->voice()->playDTMF(UUID, '2468#');

View full source

Run your code

Save this file to your machine and run it:

php index.php

Prerequisites

pip install vonage python-dotenv

Write the code

Add the following to play-dtmf-into-call.py:

from vonage import Auth, Vonage
from vonage_voice import CallMessage

client = Vonage(
    Auth(
        application_id=VONAGE_APPLICATION_ID,
        private_key=VONAGE_PRIVATE_KEY,
    )
)

response: CallMessage = client.voice.play_dtmf_into_call(
    uuid=VOICE_CALL_ID, dtmf=VOICE_DTMF_DIGITS
)

pprint(response)

View full source

Run your code

Save this file to your machine and run it:

python voice/play-dtmf-into-call.py

Prerequisites

gem install vonage

Write the code

Add the following to play-dtmf-into-call.rb:

client = Vonage::Client.new(
  application_id: VONAGE_APPLICATION_ID,
  private_key: VONAGE_PRIVATE_KEY
)

response = client.voice.dtmf.send(VOICE_CALL_ID, digits: VOICE_DTMF_DIGITS)

View full source

Run your code

Save this file to your machine and run it:

ruby play-dtmf-into-call.rb

Try it out

When you run the code a series of DTMF tones is played into the call identified with the specified UUID.

Further Reading

  • Conference Calling - This guide explains the two concepts Vonage associates with a call, a leg and a conversation.